package de.fraunhofer.iem.dataprovider.occmd

import de.fraunhofer.iem.dataprovider.repository.entity.RepositoryEntity
import de.fraunhofer.iem.dataprovider.repository.service.RepositoryService
import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.occmd.OccmdTask
import io.mockk.every
import io.mockk.mockk
import kotlinx.coroutines.ExperimentalCoroutinesApi
import kotlinx.coroutines.test.runTest
import org.junit.jupiter.api.Test
import java.nio.file.Path
import java.util.*

class OccmdTest {

    @Test
    @OptIn(ExperimentalCoroutinesApi::class)
    fun testOccmdParser() = runTest {
        suspend fun responseChannelDummy(event: Event): Unit {

        }

        val repoId = UUID.randomUUID()

        val repositoryService = mockk<RepositoryService>()
        val repoEntity = RepositoryEntity()
        repoEntity.repoId = 1108

        every { repositoryService.findRepoByID(repoId) } returns repoEntity

        val occmdTask = OccmdTask(
            repoId = repoId,
            responseChannel = ::responseChannelDummy,
            repositoryService = repositoryService,
            outputDirectory = "",
            repositoryDirectoryPath = ""
        )

        val results =
            occmdTask.parseProcessResults(Path.of("src/test/kotlin/de/fraunhofer/iem/dataprovider/occmd/occmdResults01.json"))
        assert(results.size == 3)
        assert(results[0].score == 0.0)
        assert(results[1].score == 1.0)
    }


}
